/**
  *  \file client/chart-color.cc
  */

#include "client/chart.h"
#include "game/player.h"

/** Get color scheme to use for the specified player. Classifies the
    specified player, and returns the color. */
UIColor::Color
getPlayerColor(int player)
{
    static const UIColor::Color data[] = {
        UIColor::tc_Green,
        UIColor::tc_Yellow,
        UIColor::tc_Red
    };
    
    if (player <= 0 || player >= NUM_OWNERS)
        return UIColor::tc_Static;
    else
        return getPlayerRelation(player)[data];
}
