/**
  *  \file game/error.h
  */
#ifndef PCC_V2_GAME_ERROR_H
#define PCC_V2_GAME_ERROR_H

#include "util/nls.h"

class GError {
    const char* script_error;
    const char* user_error;
 public:
    GError() : script_error(0), user_error(0) { }
    GError(const char* script_error, const char* user_error)
        : script_error(script_error), user_error(user_error) { }

    const char* getScriptError() const { return script_error; }
    const char* getUserError() const { return user_error; }

    operator bool() const { return script_error != 0; }

    static const char eFacility[], eNotOwner[], eRange[],
        ePerm[], eNoBase[], eNoResource[], ePos[], ePartial[],
        eUser[], eFleet[], eGraph[];
};

#endif
