/**
  *  \file int/vars.h
  *
  *  (c) 2001,2002,2003 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_INT_VARS_H
#define PCC_V2_INT_VARS_H

#include <vector>
#include "int/data.h"
#include "cpluslib/types.h"
#include "cpluslib/string.h"

class IntVariableNames {
    IntVariableNames& operator=(const IntVariableNames&);

    std::vector<string_t>  names;
 public:
    typedef int32 index_t;

    // default IntVariableNames(const IntVariableNames&);
    IntVariableNames();
    ~IntVariableNames();

    index_t lookup(string_t name);
    index_t add(string_t name);

    static IntVariableNames global_names;
};

class IntVariableValues {
    IntVariableValues& operator=(const IntVariableValues&);

    std::vector<IntObject>  values;
 public:
    typedef IntVariableNames::index_t index_t;

    // default IntVariableValues(const IntVariableValues&);
    IntVariableValues();
    ~IntVariableValues();

    IntObject  read(index_t);
    void       store(index_t, IntObject);

    static IntVariableValues global_values;
};

#endif
