/**
  *  \file ui/peerlink.h
  *
  *  (c) 2001,2002,2003 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_UI_PEERLINK_H
#define PCC_V2_UI_PEERLINK_H

#include "cpluslib/sigslot.h"
#include "cpluslib/object.h"

class UIPeer : public Object {
    Signal0 sig_death;
    friend class UIBasicPeerLink;
 public:
    UIPeer();
    ~UIPeer();
};

class UIBasicPeerLink {
    void*   cookie;
    UIPeer* peer;
    void    onPeerDeath();
 public:
    UIBasicPeerLink(UIPeer* peer);
    ~UIBasicPeerLink();
    UIPeer* get() const { return peer; }
    void    set(UIPeer* p);
};

template<class T>
class UIPeerLink : private UIBasicPeerLink {
 public:
    UIPeerLink(T* p = 0) : UIBasicPeerLink(p) { }
    T*    get() const { return static_cast<T*>(UIBasicPeerLink::get()); }
    void  set(T* p)   { UIBasicPeerLink::set(p); }
};

#endif
