/**
  *  \file util/file-game.cc
  */

#include "util/filepars.h"
#include "io/streams.h"
#include "io/iostr.h"
#include "game/gamedirs.h"

/** Parse a game file. Parses the specified file which is searched in the
    game directory first, then in the specification file directory. This
    automatically call setFileName(). */
bool
FileParser::parseGameFile(string_t filename)
{
    Ptr<Stream> s = spec_file_dir->openFileNT(filename, Stream::C_READ | Stream::C_TEXT);

    if (s) {
        setFileName(s->getName());
        StandardStream in(s);
        parseFile(in);
        return true;
    } else {
        return false;
    }
}
